<?php
if(!isset($_SESSION["id_konta"]))
{
header("Location: ../index.php");
}

if(isset ($_GET["o"]))
{ $opcja = $_GET["o"]; }
else
{ $opcja = 0; }

$a = new Module($db, LANGS, "produkty", $kat);
$p = new Panel($a, LANGS, $a->ref);

$options = [
    "addDisplayText" => "produkt",
    "options" => "enableGrouping",
    "groupTable" => "kategorie",
    "groupDisplayTextColumn" => "nazwa",
    "groupParentColumn" => "rodzic",
    "groupIDColumn" => "id",
    "groupLabelText" => "Wybierz kategorię:",
    "groupIndentStr" => "-",
    "groupIndentSeparator" => " ",
    // "dataTable" => true,
    "orderColumn" => "kol",
    "swapColumns" => "kol",
    "defaultSortBy" => 8,
    "inputSorting" => 8,
    "checkboxSorting" => 9
];

$renderTable = [
    "id" => [
        "name" => "ID",
        "styles" => "width: 70px; text-align: center"
    ],
    "nazwa" => [
        "name" => "Nazwa",
        "valueStyles" => "text-align: left"
    ],
    "opis" => [
        "name" => "Opis",
        "valueStyles" => "width: 15%; text-align: left",
        "value" => function($data) {
            return Utils::shortenText($data['row']['opis'], 1, 5, 35);
        }
    ],
    "kategorie" => [
        "name" => "Kategorie",
        "valueStyles" => "text-align: left",
        "valueFromTable" => "kategorie",
        "valueFromField" => "id",
        "valueDisplayTextFromField" => "nazwa",
        "multiValues" => "string",
        "multiValuesSeparator" => ",",
        "multiValuesDisplayTextSeparator" => ", "
    ],
    "zdjecie" => [
        "name" => "Zdjęcie",
        "styles" => "width: 70px; text-align: center",
        "value" => function($data) {
            return $data['row']['zdjecie'] != "" ? "&#10003;" : "";
        }
    ],
    "galeria" => [
        "name" => "Galeria",
        "styles" => "width: 70px; text-align: center",
        "value" => function($data) {
            return $data['row']['galeria'] != "" ? "&#10003;" : "";
        }
    ],
    "karta" => [
        "name" => "Karta charakterystyki",
        "styles" => "width: 70px; text-align: center",
        "value" => function($data) {
            return $data['row']['karta'] != "" ? "&#10003;" : "";
        }
    ],
    "kol" => [
        "name" => "Kolejność",
        "styles" => "width: 70px; text-align: center",
        "value" => function($data) {
            return "<form id=\"kol" .  $data['row']['id'] . "\" method=\"POST\"><input name=\"id\" type=\"hidden\" value=\"" . $data['row']['id'] . "\" /><input class=\"inline-edit-width-50 inline-edit-text-center\" type=\"text\" name=\"kol\" value=\"" . $data['row']['kol'] . "\" autocomplete=\"off\" /></form>";
        }
    ],
    "aktywny" => [
        "name" => "Aktywna",
        "styles" => "width: 70px; text-align: center",
        "value" => function($data) {
            return "<form id=\"aktywny" . $data['row']['id'] . "\" method=\"POST\"><input name=\"id\" type=\"hidden\" value=\"" . $data['row']['id'] . "\" /><input name=\"aktywny\" type=\"hidden\" value=\"0\" /><input type=\"checkbox\" name=\"aktywny\"" . ($data['row']['aktywny'] != 0 ? " checked=\"checked\"" : "") . " /></form>";
        }
    ]
];

$renderEditor = [
    "nazwa" => [
        "lang" => "single",
        "displayName" => "Nazwa",
        "displayStyles" => "width: 100px",
        "type" => "text"
    ],
    "flink" => [
        "lang" => "single",
        "displayName" => "Przyjazny link",
        "displayStyles" => "width: 100px",
        "type" => "text"
    ],
    "meta_title" => [
        "lang" => "single",
        "displayName" => "META Tytuł",
        "displayStyles" => "width: 100px",
        "type" => "text"
    ],
    "meta_desc" => [
        "lang" => "single",
        "displayName" => "META Opis",
        "displayStyles" => "width: 100px",
        "type" => "text"
    ],
    "meta_keys" => [
        "lang" => "single",
        "displayName" => "META Słowa kluczowe",
        "displayStyles" => "width: 100px",
        "type" => "text"
    ],
    "opis" => [
        "lang" => "single",
        "displayName" => "Opis",
        "displayStyles" => "width: 100px",
        "type" => "html",
        "fieldStyles" => "height: 300px"
    ],
    "kategorie" => [
        "lang" => "all",
        "displayName" => "Kategorie",
        "displayStyles" => "width: 100px; vertical-align: top; padding-top: 20px",
        "valueFromTable" => "kategorie",
        "valueFromField" => "id",
        "valueDisplayTextFromField" => "nazwa",
        "multiValues" => "string",
        "multiValuesSeparator" => ",",
        "multiValuesDisplayTextSeparator" => ", ",
        "firstEmpty" => true,
        "addButtonDisplayText" => "Dodaj kategorię",
        "type" => "multiSelectFromTable"
    ],
    "zdjecie" => [
        "lang" => "single",
        "displayName" => "Zdjęcie",
        "displayStyles" => "width: 100px",
        "type" => "image",
        "buttonStyles" => "margin-left: 20px"
    ],
    "galeria" => [
        "lang" => "single",
        "displayName" => "Galeria",
        "displayStyles" => "width: 100px",
        "type" => "image",
        "buttonStyles" => "margin-left: 20px"
    ],
    "karta" => [
        "lang" => "single",
        "displayName" => "Dokument",
        "displayStyles" => "width: 100px",
        "type" => "file",
        "buttonStyles" => "margin-left: 20px"
    ],
    "kol" => [
        "lang" => "all",
        "displayName" => "Kolejność",
        "displayStyles" => "width: 100px",
        "type" => "text"
    ],
    "aktywny" => [
        "lang" => "all",
        "displayName" => "Aktywna",
        "displayStyles" => "width: 100px",
        "type" => "checkbox",
        "fieldStyles" => "width: unset"
    ]
];

switch ($opcja){
    case 1: case 2: include_once 'dodaj.php'; break;
    default: include_once 'wyswietl.php'; break;

}

?>