(function($) {
    $.fn.bgImgCrossFader = function(options) {
        function resize() {
            try {
                var current = $(this);
                var width = current[0].naturalWidth;
                var height = current[0].naturalHeight;
                var parentWidth = current.parent().width();
                var parentHeight = current.parent().height();
                var ratio = width / height;
                var parentRatio = parentWidth / parentHeight;
                var wPerc = width * 100 / parentWidth;
                var hPerc = height * 100 / parentHeight;
                current.css({width: wPerc <= hPerc ? "100%" : "auto", height: hPerc <= wPerc ? "100%" : "auto"});
            } catch(err) {
                console.log(err);
                void(null);
            }
        }
        var self = this;
        var settings = $.extend({
            duration: 3000,
            delay: 0,
            step: 1,
            selector: "img",
            resize: true
        }, options);
        var collection = $(settings.selector, self);
        var index = 0;
        if (settings.resize) collection.each(resize);
        if (settings.class) collection.removeClass(settings.class); else collection.css({opacity: 0});
        if (settings.class) collection.first().addClass(settings.class); else collection.first().css({opacity: 1});
        if (collection.length > 1) {
            var timer = setInterval(function() {
                var collection = $(settings.selector, self);
                var len = collection.length;
                if (settings.step >= len) settings.step = -1;
                var indexOld = index;
                index += settings.step;
                if (index < 0) index += len - 1;
                index %= len;
                if (settings.class) collection.eq(index).addClass(settings.class); else collection.eq(index).css({opacity: 1});
                if (settings.delay > 0) setTimeout(function() {
                    if (settings.class) collection.eq(indexOld).removeClass(settings.class); else collection.eq(indexOld).css({opacity: 0});
                }, settings.delay); else if (settings.class) collection.eq(indexOld).removeClass(settings.class); else collection.eq(indexOld).css({opacity: 0});
            }, settings.duration);
        }
        var resizeTimer = new Date().getTime();
        var timestamp;
        if (settings.resize) $(window).on("resize.bgImgCrossFader", function() {
            timestamp = new Date().getTime();
            if (timestamp - resizeTimer < 100) return false;
            collection.each(resize);
        });
    }
}(jQuery));