<?php

session_start();

ob_start();

if ($_SERVER["REQUEST_METHOD"] != "POST") {
    http_response_code(405);
    exit();
}

$formName = isset($formName) ? $formName : (isset($_POST['formName']) ? $_POST['formName'] : "form");
$_SESSION[$formName]['state'] = "sending";

@require_once 'get-location.php';
@require_once 'get-config.php';
@require_once 'form-prepare.php';

if ($_SESSION[$formName]['state'] == "sending") {
    $state = "sending";
    if ($_SESSION[$formName]['securityTest']['a'] + $_SESSION[$formName]['securityTest']['b'] == $_SESSION[$formName]['security']) {
        unset($_SESSION[$formName]['securityTest']);
        require_once('vendor/phpmailer/class.phpmailer.php');    //dodanie klasy phpmailer
        require_once('vendor/phpmailer/class.smtp.php');    //dodanie klasy smtp

        $from = $config['formMailSender'];
        $fromName = $config['formMailSenderName'];
        $to = isset($config['formMailReceiver']) ? $config['formMailReceiver'] : $from;
        $toName = $fromName;
        $replyTo = isset($_SESSION[$formName]['email']) ? $_SESSION[$formName]['email'] : $to;
        $replyToName = isset($_SESSION[$formName]['name']) ? $_SESSION[$formName]['name'] : $to;
        $site = $config['company'];
        $topic = "Formularz kontaktowy ze strony " . $domain;
        $topic = stripslashes($topic);
        $message = isset($_SESSION[$formName]['message']) ? $_SESSION[$formName]['message'] : "";

        // DATA FOR MAIL TEMPLATE
        foreach ($_POST[$formName] as $key => $item) {
            $config["input" . ucfirst(substr($key, 0, 1)) . substr($key, 1)] = $item;
        }

        $clientIP = $_SERVER['REMOTE_ADDR'];
        $currentDate = date("Y-m-d H:i:s", time()) . " (" . (['niedziela', 'poniedziałek', 'wtorek', 'środa', 'czwartek', 'piątek', 'sobota'][date('w')]) . ")";
        
        // READ MAIL TEMPLATE
        while (!file_exists('templates/mail.php') && $iteration++ < $maxIteration) {
            chdir("..");
        }

        if (file_exists('templates/mail.php')) {
            ob_start();
            @include_once "templates/mail.php";
            $buffer = ob_get_clean();
            @require "vendor/kaczka/template-process.php";
            $mailMessage = $buffer;
            ob_start();
            @include_once "templates/mail-html.php";
            $buffer = ob_get_clean();
            @require "vendor/kaczka/template-process.php";
            $HTMLMailMessage = $buffer;
        } else {
            $HTMLMailMessage = "W dniu " . (date("Y-m-d H:i:s", time())) . " wysłano formularz kontaktowy ze strony <a href=\"" . HOME_URLSTATIC . "\" target=\"_blank\">" . DOMENA . "</a>.<br /><br />
            <table>" . (isset($replyToName) && $replyToName != "" ? "
                <tr>
                    <td style=\"font-weight: bold; text-align: right\">" . FORM_FULL_NAME . "</td>
                    <td>{$replyToName}</td>
                </tr>" : "") . (isset($replyTo) && $replyTo != "" ? "
                <tr>
                    <td style=\"font-weight: bold; text-align: right\">" . FORM_MAIL . "</td>
                    <td>{$replyTo}</td>
                </tr>" : "") . (isset($message) && $message != "" ? "
                <tr>
                    <td colspan=\"2\" style=\"font-weight: bold; text-align: center\">" . FORM_MESSAGE_CONTENT . "</td>
                </tr>
                <tr>
                    <td colspan=\"2\">{$message}</td>
                </tr>" : "") . "
            </table>
            <br /><br />Wiadomość została wygenerowana automatycznie, prosimy na nią nie odpowiadać.";
        }

        // CHECK TEMPLATE
        // echo $HTMLMailMessage;
        // echo "<br><pre>{$mailMessage}</pre>";
        // die();

        // tworzenie i ustawienie maila
        $mail = new PHPMailer();    //utworzenie nowej klasy phpmailer
        $mail->CharSet = "UTF-8";
        $mail->Host = $config['formMailSenderHost'];    //adres serwera SMTP wysyłającego e-mail
        $mail->Mailer = "smtp";    //do wysłania zostanie użyty serwer SMTP
        $mail->SMTPAuth = true;    //włączenie autoryzacji do serwera SMTP
        $mail->Username = $from;    //nazwa użytkownika do skrzynki e-mail cms@kaczka.com
        $mail->Password = isset($config['formMailSenderPass']) ? $config['formMailSenderPass'] : "";    //hasło użytkownika do skrzynki e-mail
        $mail->Port =  isset($config['formMailSenderPort']) ? $config['formMailSenderPort'] : 587; //port serwera SMTP zależny od konfiguracji dostawcy usługi poczty
        $mail->SetLanguage("pl", "phpmailer/language/");

        $mail->From = $from;
        $mail->FromName = $fromName;
        $mail->AddAddress($to, $toName);
        $mail->AddReplyTo($replyTo, $replyToName);
        $mail->AddCC($config["mail"], $config["name"] . " " . $config["surname"]);
        $mail->Subject = $topic;
        @$mail->Body = $HTMLMailMessage;
        @$mail->AltBody = $MailMessage;
        $mail->IsHTML(true);

        if ($mail->Send()) {    //sprawdzenie wysłania, jeśli wiadomość została pomyślnie wysłana
            $state = $message = "send-success";
        } else { //w przeciwnym wypadku
            $state = "ready";
            $message = "send-error";
        }
        $mail->ClearAddresses();
        $mail->ClearAttachments();
    } else {
        $state = "ready";
        $message = "verification-error";
    }
} else {
    $state = "ready";
    $message = "not-send";
}

$_SESSION[$formName] = array_merge($_SESSION[$formName], ["state" => $state, "stateMessage" => $message]);

ob_end_clean();

http_response_code(200);
header("Location: {$formRedirect}");
exit();
