<?php

$_onlyImages = isset($onlyImages) ? ($onlyImages === true ? true : false) : true;

$_galleryRoot = trim((isset($galleryRoot) ? $galleryRoot : "img/gallery"), "\\/");
$_galleryThumbs = trim((isset($galleryThumbs) ? $galleryThumbs : "thumbs"), "\\/");
if (!isset($disableAllInOne) || $disableAllInOne !== true) $_allInOne = true;

if (!isset($categories) || (gettype($categories) == "array" && count($categories) == 0)) {
    if (file_exists($_galleryRoot . "categories.ini")) $categories = parse_ini_file($_galleryRoot . "categories.ini"); else {
        $categories = glob($_galleryRoot . "*/");
        foreach ($categories as $key => $item) {
            $name = basename($item);
            $categories[$name] = $name;
            unset($categories[$key]);
        }
    }
}

if (gettype($categories) != "array") $categories = [$categories => $categories];

$gallery = [];

if (isset($_allInOne) && $_allInOne === true) {
    $allInOne = new stdClass();
    $allInOne->id = "wszystko";
    $allInOne->name = "Wszystko";
    $allInOne->rootDir = $_galleryRoot;
    $allInOne->dir = "";
    $allInOne->files = [];
    array_push($gallery, $allInOne);
}

$i = 1;
foreach ($categories as $dir => $name) {
    $object = new stdClass();
    $object->id = "category-" . $i++ . "-" . preg_replace("/[^0-9a-z\-_]/", "", str_replace(preg_split("//u", "ąćęłńóśźż ", -1, PREG_SPLIT_NO_EMPTY), preg_split("//u", "acelnoszz-", -1, PREG_SPLIT_NO_EMPTY), mb_strtolower($name)));
    $object->name = $name;
    $object->rootDir = trim($_galleryRoot, "\\");
    $object->dir = trim($dir, "\\/");
    $object->files = [];
    $object->path = $object->rootDir;
    if ($object->dir != "") $object->path .= "/{$object->dir}";
    $files = glob("{$object->path}/*");
    if (file_exists("{$object->path}/metadata.ini")) $metadata = parse_ini_file("{$object->path}/metadata.ini", true); else $metadata = [];
    $j = 1;
    $allInOneCounter = 1;
    foreach ($files as $file) {
        if (!file_exists($file) || is_dir($file)) continue;
        if (file_exists("{$object->path}/metadata.ini") && $file == "{$object->path}/metadata.ini") continue;
        if ($_onlyImages === true && !($data = @getimagesize($file)) && @exif_imagetype($file)) continue;
        $f = new stdClass();
        $f->src = $file;
        $f->path = $object->path . "/";
        $f->filename = basename($file);
        if ($_onlyImages === true) {
            $f->width = $data[0];
            $f->height = $data[1];
        }
        $thumb = "{$object->path}/" . $_galleryThumbs . "/" . $f->filename;
        if (file_exists($thumb) && ($data = @getimagesize($thumb)) && @exif_imagetype($thumb)) {
            $f->thumbSrc = $thumb;
            if ($data) {
                $f->thumbWidth = $data[0];
                $f->thumbHeight = $data[1];
            }
        } else {
            $f->thumbSrc = $f->src;
            if (isset($f->width)) $f->thumbWidth = $f->width;
            if (isset($f->height)) $f->thumbHeight = $f->height;
        }
        // $f->description = preg_replace("/\.(jpe?gx?|pnga?|gif|webp|bmp|jfif)$/i", "", $f->filename);
        $f->description = $f->filename;
        if (strrpos($f->filename, ".") !== false) $f->description = substr($f->filename, 0, strrpos($f->filename, "."));
        foreach ($metadata as $key => $meta) {
            if (isset($meta[$f->filename])) $f->$key = $meta[$f->filename];
        }
        $f->id = "file-" . $j++ . "-" . preg_replace("/[^0-9a-z\-_]/", "", str_replace(preg_split("//u", "ąćęłńóśźż ", -1, PREG_SPLIT_NO_EMPTY), preg_split("//u", "acelnoszz-", -1, PREG_SPLIT_NO_EMPTY), mb_strtolower($f->description)));
        $f->category_id = $object->id;
        $f->category = $name;
        // if (isset($descriptions[$f->filename])) $f->description = $descriptions[$f->filename];
        array_push($object->files, $f);
        if (isset($_allInOne) && $_allInOne === true) {
            $f->id = "file-all-in-one-" . ($allInOneCounter++);
            $f->category_id = "category-all-in-one";
            array_push($allInOne->files, $f);
        }
    }
    array_push($gallery, $object);
}

// echo "<pre class=\"text-left\">";
// print_r($gallery);
// echo "</pre>";
