<?php

$response = [
    "code" => 500,
    "message" => "BAD_QUERY",
    "messageText" => "Unsupported query",
    "state" => "error",
    "requestedMehod" => $data->method,
    "requestUri" => $data->requestUri
];
$responseHeaders = [
    "Content-Type" => "application/json"
];
$newLocation = false;

if (isset($_GET["redirectBack"]) && isset($_SERVER["HTTP_REFERER"])) {
    $newLocation = $_SERVER["HTTP_REFERER"];
    $newLocationMessage = "REDIRECT_USER_BACK";
    $newLocationMessageText = "Redirect user back";
}

if (isset($_GET["redirect"]) && $_GET["redirect"] != "") {
    $newLocation = $_GET["redirect"];
    $newLocationMessage = "REDIRECT_USER_TO_GIVEN_URL";
    $newLocationMessageText = "Redirect user to given URL";
}

// API CALLED, CHECK IF "API" IS IN URI REQUEST /api/
// IF NOT THEN EXIT SCRIPT
if (isset($routes) && isset($routes[0]) && array_shift($routes) == "api") {
    if (!isset($routes[0])) {
        $response = array_merge($response, [
            "code" => 500,
            "message" => "UNEXPECTED_END_OF_QUERY",
            "messageText" => "Unexpected end of query"
        ]);
    }

    // GET METHODS
    else if ($data->method == "GET") {
        $route = array_shift($routes);
        if ($route == "self_diagnosis") {
            $route = array_shift($routes);
            $tables = ["partie" => "partie", "objawy" => "objawy", "choroby" => "choroby"];
            $tablesKeys = array_keys($tables);
            if ($route == $tablesKeys[0]) {
                $query = "SELECT p.`id`, p.`nazwa`, p.`opis`, p.`pos_bottom`, p.`line_width` FROM `{$tables[$route]}{$lang}` p WHERE p.`aktywny` = 1";
                $route = array_shift($routes);
                if ($route != null) {
                    $route = preg_replace("/[^\d,]/", "", $route);
                    $partsID = $route;
                    $query .= " AND p.`id` IN ({$partsID})";
                }
                $query .= " ORDER BY `kolejnosc` ASC";
                $route = array_shift($routes);
                if ($route != null && $route == $tablesKeys[1]) {
                    // select o.id, o.nazwa, o.choroby, o.partie, COUNT(*) AS `moc` FROM objawy o JOIN partie p ON p.aktywny = 1 AND FIND_IN_SET(p.id, o.partie) AND p.id IN (1,3) WHERE o.aktywny = 1 GROUP BY o.id ORDER BY moc DESC, o.id ASC
                    $query = "SELECT o.`id`, o.`nazwa`, o.`opis`, o.`choroby`, o.`partie`, COUNT(*) AS `moc` FROM `{$tables[$route]}{$lang}` o JOIN `{$tablesKeys[0]}{$lang}` p ON p.`aktywny` = 1 AND FIND_IN_SET(p.`id`, o.`partie`) AND p.`id` IN ({$partsID}) WHERE o.`aktywny` = 1";
                    $route = array_shift($routes);
                    if ($route != null) {
                        $route = preg_replace("/[^\d,]/", "", $route);
                        $symptomsID = $route;
                        $query .= " AND o.`id` IN ({$symptomsID})";
                    }
                    $query .= " GROUP BY o.`id` ORDER BY `moc` DESC, o.`id` ASC";
                    $route = array_shift($routes);
                    if ($route != null && $route == $tablesKeys[2]) {
                        // select c.id, c.nazwa, c.partie, a.nazwa, a.opis, a.flink, a.url, COUNT(*) AS `moc` FROM choroby c LEFT JOIN artykuly a ON a.aktywny = 1 AND FIND_IN_SET(a.id, c.artykul) JOIN objawy o ON o.aktywny = 1 AND FIND_IN_SET(c.id, o.choroby) AND o.id IN (46,48) JOIN partie p ON p.aktywny = 1 AND FIND_IN_SET(p.id, o.partie) AND p.id IN (1,3) WHERE c.aktywny = 1 GROUP BY c.id ORDER BY moc DESC, (LENGTH(c.partie) - LENGTH(REPLACE(c.partie, ",", "")) + 1) DESC, c.id ASC
                        $query = "SELECT c.`id`, c.`skrot`, c.`nazwa`, c.`opis`, a.`nazwa` AS `artykul_nazwa`, a.`flink`, a.`url`, COUNT(*) AS `moc` FROM `{$tables[$route]}{$lang}` c LEFT JOIN `artykuly{$lang}` a ON a.`aktywny` = 1 AND FIND_IN_SET(a.`id`, c.`artykul`) JOIN `{$tables[$tablesKeys[1]]}{$lang}` o ON o.`aktywny` = 1 AND FIND_IN_SET(c.`id`, o.`choroby`) AND o.`id` IN ($symptomsID) JOIN `{$tables[$tablesKeys[0]]}{$lang}` p ON p.`aktywny` = 1 AND FIND_IN_SET(p.`id`, o.`partie`) AND p.`id` IN ({$partsID}) WHERE c.`aktywny` = 1";
                        $cond = preg_replace_callback("/(?:^|,|$)([^,]+)/", function($f) use (&$i) {
                            if (!isset($i)) $i = 1;
                            else $i++;
                            return ($i == 1 ? " AND (" : " OR ") . "FIND_IN_SET('{$f[1]}', c.`partie`)";
                        }, $partsID) . ")";
                        $query .= $cond;
                        $route = array_shift($routes);
                        if ($route != null) {
                            $route = preg_replace("/[^\d,]/", "", $route);
                            $diseasesID = $route;
                            $query .= " AND c.`id` IN ({$diseasesID})";
                        }
                        $query .= " GROUP BY c.`id` ORDER BY `moc` DESC, (LENGTH(c.`partie`) - LENGTH(REPLACE(c.`partie`, \",\", \"\")) + 1) DESC, c.`id` ASC";
                    }
                }
                $result = $data->db->query($query);
                $response = array_merge($response, [
                    "code" => 200,
                    "message" => "DATA_ACCESSED",
                    "messageText" => "Data accessed",
                    "state" => "success",
                    "data" => $result
                ]);
            } else {
                $response = array_merge($response, [
                    "code" => 404,
                    "message" => "DATA_NOT_FOUND",
                    "messageText" => "Data not found"
                ]);
            }
        }
    }

    // POST METHODS
    else if ($data->method == "POST") {
        $route = array_shift($routes);
        if ($route == "cookies") { // API FOR COOKIES
            $route = array_shift($routes);
            if ($route == "accept") { // ACCEPTING
                setcookie("cookiesAccepted", 1, time() + 30 * 24 * 60 * 60, "/"); // 30 days
                $response = array_merge($response, [
                    "code" => 200,
                    "message" => "COOKIES_ACCEPTED",
                    "messageText" => "Cookies accepted",
                    "state" => "success"
                ]);
            }
            else if ($route == "reject") { // REJECTING
                setcookie("cookiesAccepted", NULL, time() - 30 * 24 * 60 * 60, "/"); // 30 days
                $response = array_merge($response, [
                    "code" => 200,
                    "message" => "COOKIES_REJECTED",
                    "messageText" => "Cookies rejected",
                    "state" => "success"
                ]);
            }
            if ($response["state"] != "success") {
                $_SESSION["apiCookiesError"] = true;
            }
        }
    }
}

// API REQUEST PROCESSED SUCCESSFULLY
// RETURN RESULT BY DEFAULT
http_response_code($response["code"]);
unset($response["code"]);
foreach ($responseHeaders as $header => $value) header("{$header}: {$value}");
if ($newLocation) {
    $response["message"] = "{$newLocationMessage}_AND_{$response['message']}";
    $response["messageText"] = "{$newLocationMessageText}; {$response['messageText']}";
}
echo json_encode($response);
if ($newLocation) header("Location: $newLocation");
exit();
