<?php

error_reporting(-1);
ini_set('error_reporting', E_ALL);

date_default_timezone_set("Europe/Warsaw");
mb_internal_encoding("UTF-8");

if (!DEFINED("PHP_INT_MIN")) DEFINE("PHP_INT_MIN", -PHP_INT_MAX - 2);

// filtrowanie ogólne wszystkich zmiennych z $_POST:
function filter(&$data) {
    foreach ($data as $dK => &$dV) {
        if (gettype($dV) == "array") filter($dV);
        else {
        $dV = trim(htmlentities(strip_tags(preg_replace("/<br.*?(?<!\\\\)>/is", "\n", $dV))));
        if (@get_magic_quotes_gpc())
            $dV = stripslashes($dV);
        }
    }
}

filter($_GET);
filter($_POST);

$now = getdate();
$now[1] = mktime(0, 0, 0, $now['mon'], $now['mday']);
$now[2] = $now['hours'] * 60 * 60 + $now['minutes'] * 60 + $now['seconds'];
$now[3] = $now['year'] . "-" . str_pad($now['mon'], 2, "0", STR_PAD_LEFT) . "-" . str_pad($now['mday'], 2, "0", STR_PAD_LEFT);
$now[4] = $now['hours'] . ":" . str_pad($now['minutes'], 2, "0", STR_PAD_LEFT) . ":" . str_pad($now['seconds'], 2, "0", STR_PAD_LEFT);

$data = new stdClass();

$data->method = $_SERVER["REQUEST_METHOD"];
$data->protocol = isset($_SERVER["REQUEST_SCHEME"]) ? $_SERVER["REQUEST_SCHEME"] : "http";
if (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] = "on") $data->protocol = "https";
$data->domain = $_SERVER["HTTP_HOST"];
$data->root = substr($_SERVER["SCRIPT_NAME"], 0, strrpos($_SERVER["SCRIPT_NAME"], "/") + 1);
$data->staticRoot = "{$data->protocol}://{$data->domain}{$data->root}";

$data->requestUri = substr_replace($_SERVER["REQUEST_URI"], "", 0, strlen($data->root));
$data->uri = strpos($data->requestUri, "?") === false ? $data->requestUri : substr($data->requestUri, 0, strpos($data->requestUri, "?"));
$data->query = strpos($data->requestUri, "?") === false ? "" : substr($data->requestUri, strpos($data->requestUri, "?") + 1);
while (stripos($data->query, "??") !== false || stripos($data->query, "?&") !== false || stripos($data->query, "&&") !== false) $data->query = str_replace(["??", "?&", "&&"], ["?", "?", "&"], $data->query);
$data->query = trim($data->query, "?&");
$data->requestUri = "{$data->uri}" . ($data->query != "" ? "?{$data->query}" : "");
$data->uriData = [];

$data->lang = "";
$data->buffer = "";

while (ob_get_level() > 0) ob_end_clean();
ob_start(function($b) use ($data) {
    $data->buffer .= $b;
    return false;
});

require_once "core/config.php";

session_name("_" . preg_replace("/[^a-z0-9]/", "", strtolower($domain)));
session_start();

if (!isset($_SESSION["PREVIOUS_URL"])) {
    $_SESSION["PREVIOUS_URL"] = [];
} else {
    $_SESSION["PREVIOUS_URL"] = array_slice($_SESSION["PREVIOUS_URL"], -2, 2);
}

if ($data->requestUri != array_slice($_SESSION["PREVIOUS_URL"], -1, 1)) array_push($_SESSION["PREVIOUS_URL"], $data->requestUri);
$_SESSION["PREVIOUS_URL"] = array_unique($_SESSION["PREVIOUS_URL"]);

$data->previousUrl = $data->staticRoot . array_slice($_SESSION["PREVIOUS_URL"], -2, 1)[0];

require_once "core/connection.php";

$data->db = new db("pdo", $currEnv["DB_SERVER"], $currEnv["DB_USER"], $currEnv["DB_PASS"], $currEnv["DB_NAME"]);

unset($currEnv["DB_SERVER"]);
unset($currEnv["DB_USER"]);
unset($currEnv["DB_PASS"]);
unset($currEnv["DB_NAME"]);

foreach ($currEnv as $envKey => $envVal) {
      if (!DEFINED($envKey)) DEFINE($envKey, $envVal);
}

unset($currEnv);
unset($env);
unset($envSet);
unset($envHosts);

$data->defLang = explode(",", LANGS)[0];

$routes = explode("/", $data->uri);

// LANGUAGE

$langs = explode(",", LANGS);
$lang = isset($_SESSION["lang"]) ? $_SESSION["lang"] : "";

// FROM QUERY STRING

if (isset($_GET["lang"]) && $_GET["lang"] != "") {
    if (array_search($_GET["lang"], $langs) !== false) {
      $lang = $_GET["lang"];
      while (stripos($data->query, "lang=") !== false) $data->query = str_replace("lang={$lang}", "", $data->query);
      while (stripos($data->query, "??") !== false || stripos($data->query, "?&") !== false || stripos($data->query, "&&") !== false) $data->query = str_replace(["??", "?&", "&&"], ["?", "?", "&"], $data->query);
      $data->query = trim($data->query, "?&");
    }
}

// FROM URI

if ($routes[0] != "") {
    if (array_search($routes[0], $langs) !== false) {
        $lang = array_shift($routes);
        $data->uri = implode("/", $routes);
    }
    // TODO: OPTION FOR REDIRECT AFTER LANGUAGE SET
}

// FROM SESSION OR SAVE TO SESSION

if ($lang == "") {
    if (isset($_SESSION["lang"])) $lang = $_SESSION["lang"];
} else $_SESSION["lang"] = $lang;

// IS DEFAULT LANG?
if ($lang == $langs[0]) $lang = "";

$data->lang = $lang;

// TEMPLATING SYSTEM DATA

$data->deps = [
    "path" => "assets",
    "header" => [
        "css" => [
            PHP_INT_MIN => ["vendor/lightGallery/css/lightgallery.min.css"],
            PHP_INT_MIN => ["vendor/lightSlider/css/lightslider.min.css"],
            PHP_INT_MAX => ["css/style.min.css"]
        ],
        "js" => [
            PHP_INT_MIN => ["vendor/jquery/js/jquery-3.4.1.min.js"],
            PHP_INT_MIN + 2 => ["vendor/lightSlider/js/lightslider.min.js"],
            PHP_INT_MIN + 1 => ["vendor/lightGallery/js/lightgallery-all.min.js"]
        ]
    ],
    "footer" => [
        "css" => [],
        "js" => []
    ]
];

if (file_exists("vendor/browser/Browser.php")) {
    include_once "vendor/browser/Browser.php";

    $browser = new Browser();
    // IE
    if ($browser->getBrowser() == Browser::BROWSER_IE) {
        array_splice($data->deps["header"]["css"][PHP_INT_MAX], 1, 0, ["css/style-ie.min.css"]);
    }
    // IE9
    if ($browser->getBrowser() == Browser::BROWSER_IE && $browser->getVersion() <= 9) {
        array_splice($data->deps["header"]["css"][PHP_INT_MAX], 1, 0, ["css/style-ie9.min.css"]);
        if (count($routes) > 1) $data->root = $data->staticRoot; // IE9 URI CORRECTION
    }
}

// var_dump($browser->getBrowser(), $browser->getVersion(), $data->deps["header"]["css"]);
// die();

// DEPENDENTS LIST
// "header" => [
//     "CSS" => [
//         10 => "css/style.css"
//     ],
//     "JS" => [
//         10 => "js/main.js"
//     ]
// ]

$data->tplData = [
    "" => "", // DUMMY, ENABLING FUNCTION CALLINGS WITHOUT REAL VARIABLE IN CMS
    "STATIC_ROOT" => $data->staticRoot,
    "CURRENT_DOMAIN" => $data->domain,
    "ROOT" => $data->root,
    "PREVIOUS_URI" => $data->previousUrl,
    "CURRENT_URI" => $data->requestUri,
    "PATH_ASSETS" => trim(defined("ASSETS") ? ASSETS : $data->staticRoot . "assets/", "\\/") . "/",
    "PATH_USERFILES" => trim(defined("UPLOAD_DIR") ? UPLOAD_DIR : $data->staticRoot . "userfiles/", "\\/") . "/",
    "HEADER_CSS" => "",
    "HEADER_JS" => "",
    "FOOTER_CSS" => "",
    "FOOTER_JS" => "",
    "TOP_HTML" => "",
    "BOTTOM_HTML" => "",
    "CURRENT_DAY" => $now['mday'],
    "CURRENT_MONTH" => $now['mon'],
    "CURRENT_YEAR" => $now['year'],
    "WEBPAGE_PROJECT_BY" => [
        "" => "Strona zaprojektowana przez",
        "en" => "Webpage projected by"
    ][$lang],
    "WEBPAGE_PROJECT_BY_LOGO" => "{%PATH_ASSETS%}img/kaczka.png",
    "WEBPAGE_PROJECT_BY_LINK" => "http://www.strony.com.pl/",
    "LOREM_IPSUM" => function() {
        $args = func_get_args();
        $opts = [];
        array_walk_recursive($args, function($item) use (&$opts) {
            array_push($opts, $item);
        });
        $opts = implode("/", $opts);
        if ($opts != "") $opts = "/{$opts}";
        /* API Options:
        (integer) - The number of paragraphs to generate.
        short, medium, long, verylong - The average length of a paragraph.
        decorate - Add bold, italic and marked text.
        link - Add links.
        ul - Add unordered lists.
        ol - Add numbered lists.
        dl - Add description lists.
        bq - Add blockquotes.
        code - Add code samples.
        headers - Add headers.
        allcaps - Use ALL CAPS.
        prude - Prude version.
        plaintext - Return plain text, no HTML.
        */
        return file_get_contents("https://loripsum.net/api{$opts}");
    },
    "SET" => function($name, $value) use (&$data) {
        if (isset($name) && $name != "") $data->tplData[$name] = $value;
    },
    "PREPEND" => function($name, $value) use (&$data) {
        if (isset($name) && $name != "") {
            $data->tplData[$name] = $data->tplData[$name] . $value;
        } else $data->tplData[$name] = $value;
    },
    "APPEND" => function($name, $value) use (&$data) {
        if (isset($name) && $name != "") {
            $data->tplData[$name] .= $value;
        } else $data->tplData[$name] = $value;
    },
    "LOWERCASE" => function($name) use (&$data) {
        if (isset($name) && $name != "") $data->tplData[$name] = mb_strtolower($data->tplData[$name]);
    },
    "UPPERCASE" => function($name) use (&$data) {
        if (isset($name) && $name != "") $data->tplData[$name] = mb_strtoupper($data->tplData[$name]);
    }
];  // TEMPLATE DATA

if ($data->lang == "") $data->currentLang = $data->tplData["LANG"] = $data->defLang; else $data->currentLang = $data->tplData["LANG"] = $data->lang;
$data->tplData["CHARSET"] = "UTF-8";

if (!isset($_COOKIE["META_VIEWPORT"])) $data->tplData["META_VIEWPORT"] = PHP_EOL . "    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">";

if (!isset($_COOKIE['cookiesAccepted']) || $_COOKIE['cookiesAccepted'] != 1) {
    if (file_exists("js/js.cookie.min.js")) array_push($data->deps["header"]["js"][1], "js/js.cookie.min.js");
    $apiError = false;
    if (isset($_SESSION["apiCookiesError"]) && $_SESSION["apiCookiesError"] === true) {
        $htmlError = "<span class=\"cookies-box-error\"> {%COOKIES_ERROR%}</span>";
        $_SESSION["apiCookiesError"] = false;
        unset($_SESSION["apiCookiesError"]);
    } else $htmlError = "";
    $escapedCookiesText = isset($data->tplData["COOKIES_ERROR"]) ? addcslashes($data->tplData["COOKIES_ERROR"], '"') : "";
    $data->tplData["COOKIES_HTML"] = <<<HTML
    <div class="cookies-box">
        <div>{%COOKIES_INFO_BAR%}{$htmlError}</div>
        <div>
            <form name="acceptCookiesForm" action="api/cookies/accept?redirectBack" method="POST">
                <input type="submit" value="OK" />
            </form>
        </div>
    </div>
    <script type="text/javascript">
        $(document).ready(function() {
            var cookiesBox = $(".cookies-box");
            var form = cookiesBox.find("form[name='acceptCookiesForm']");
            form.on("submit", function(event) {
                event.stopPropagation();
                event.preventDefault();
                $.ajax({
                    context: cookiesBox,
                    url: 'api/cookies/accept',
                    method: 'POST',
                    success: function(data) {
                        $(this).fadeOut();
                    },
                    error: function(data) {
                        try {
                            Cookies.set("cookiesAccepted", 1, {path: "/", expires: 30});
                            $(this).fadeOut();
                        } catch(err) {
                            var div = $(this).find("div");
                            if (div.length < 2) div = form.parent().prepend("<div></div>"); else div = div.eq(0);
                            var span = div.find("span");
                            if (span.length < 1) {
                                span = $("<span class=\"cookies-box-error\"></span>");
                                div.append(span);
                            }
                            span.text(" {$escapedCookiesText}");
                        }
                    }
                });
                return false;
            });
        });
    </script>
HTML;
}

$data->tplData["MODALS_HTML"] = "";
$data->tplData["BOTTOM_HTML"] .= "{%MODALS_HTML%}";
$modalCounter = 0;
$data->tplData["MODAL_HTML"] = function($html, $delay = 0, $id = null, $expires = "7 days") use (&$data, &$modalCounter) {
    if (!isset($id)) $id = ++$modalCounter; else $id = intval($id);
    if (!isset($_COOKIE["user-modal-{$id}"]) || $_COOKIE["user-modal-{$id}"] !== "shown") {
        setcookie("user-modal-{$id}", "shown", strtotime($expires));
        ob_start();
        if (!isset($delay)) $delay = 0; else $delay = intval($delay);
        echo "<div class=\"user-modal\" data-modal-id=\"" . $id . "\" data-modal-delay=\"{$delay}\">{$html}</div>";
        $modal = ob_get_clean();
        $data->deps["footer"]["js"][1001] = ["js/modals.min.js"];
        return $modal;
    }
};

$data->tplData["MODAL"] = function($html, $delay = 0, $id = null, $expires = "7 days") use (&$data, &$modalCounter) {
    $data->tplData["MODALS_HTML"] .= $data->tplData["MODAL_HTML"]($html, $delay, $id, $expires);
    return "";
};

$data->tplData["MODAL_TEXT"] = function($textID = null, $delay = 0, $id = null, $expires = "7 days") use (&$data, &$modalCounter) {
    if (!isset($textID)) $textID = null;
    if ($textID == null) return "";
    if (!isset($data->tplData["TEXT_{$textID}"])) return "";
    $data->tplData["MODALS_HTML"] .= $data->tplData["MODAL"]($data->tplData["TEXT_{$textID}"], $delay, $id, $expires);
    return "";
};

// AS WE GOT LANGUAGE, INCLUDE HYPHENATOR WITH PROPER LANGUAGE

if (file_exists("assets/vendor/jquery.hypher/hypher-languages/{$data->currentLang}.js")) $data->deps["header"]["js"][50] = ["vendor/jquery.hypher/jquery.hypher.min.js", "vendor/jquery.hypher/hypher-languages/{$data->currentLang}.js"];

require_once "core/includes.php";

// NOW WE CAN FILL DEFINED LOCALES

$locales = $data->db->select("locales{$data->lang}");
foreach ($locales as $l) {
    if (!DEFINED($l["nazwa"])) DEFINE($l["nazwa"], $l["tekst"]);
    $data->tplData[$l["nazwa"]] = $l["tekst"];
}

$data->currentMenu = [
    "id" => false,
    "nazwa" => DEFINED("COMPANY_NAME") ? COMPANY_NAME : (DEFINED("COMPANY_FULL_NAME") ? COMPANY_FULL_NAME : ($data->domain)),
    "rodzic" => false,
    "tekst" => false,
    "typszablonu" => "home.php",
    "flink" => "",
    "kolejnosc" => false,
    "przekierowanie" => "",
    "grafika" => "",
    "pokaz" => 1,
];
$data->currentMenu["title"] = $data->currentMenu["nazwa"];
$data->currentMenu["description"] = $data->currentMenu["nazwa"];
$data->currentMenu["keywords"] = $data->currentMenu["nazwa"];

// GET CMS CONTENT (TEXTS, MENUS)

$tytuly = [];
$teksty = [];
$inne = [];
Utils::getTexts($data->db, "tytul", $tytuly, "tresc", $teksty, $inne, "teksty", $data->lang, [], []); // last arguments (array) is an array of IDs to be stripped from tags - titles and texts

$menu = Utils::getMenus($data->db, "menu", $data->lang);

foreach ($teksty as $i => $v) {
    $data->tplData["TITLE_{$i}"] = $tytuly[$i];
    $data->tplData["TEXT_{$i}"] = $v;
    if ($inne[$i]["aktywny"] == 1) {
        foreach ($inne[$i] as $tK => $tV) {
            $k = str_replace(["Ą", "Ć", "Ę", "Ł", "Ń", "Ó", "Ś", "Ź", "Ż"], ["A", "C", "E", "L", "N", "O", "S", "Z", "Z"], mb_strtoupper($tK));
            $k = "TEXT_{$i}_" . trim(preg_replace("/_{2,}/", "_", preg_replace("/[^A-Z0-9_]+/", "_", $k)), "_");
            $data->tplData[$k] = $tV;
        }
    }
}

require_once "core/routes_cms_required.php";

$skip = [];
foreach ($data->tplData as $k => $v) if ($v == "") array_push($skip, $k);

$data->bread = Utils::generateBreadcrumbs($menu, $data->currentMenu["id"]);

if (file_exists("custom/tplData.php")) include_once "custom/tplData.php";
if (file_exists("custom/routes.php")) include_once "custom/routes.php";

if ($routeCheckResponseCode >= 300) {
    http_response_code($routeCheckResponseCode);
    exit();
}

// SETTING ADDITIONAL FIELDS FOR TEMPLATES AFTER SOLVING ROUTES

if ($data->currentMenu["id"] != 1) {
    $data->currentMenu["keywords"] = implode(",", array_unique(array_merge(explode(",", $data->currentMenu["keywords"]), explode(",", $menu[1]["keywords"]))));
}

$data->tplData["TITLE"] = $data->currentMenu["title"];
if ($data->tplData["TITLE"] == "") $data->tplData["TITLE"] = $data->currentMenu["nazwa"];
$data->tplData["MENU_NAME"] = $data->currentMenu["nazwa"];
$data->tplData["MENU_TITLE"] = $data->currentMenu["title"];
$data->tplData["MENU_DESCRIPTION"] = $data->currentMenu["description"];
$data->tplData["MENU_KEYWORDS"] = $data->currentMenu["keywords"];
$data->tplData["MENU_IMAGE"] = $data->currentMenu["grafika"];

$data->tplData["CMS_TITLE"] = isset($tytuly[$data->currentMenu['tekst']]) ? $tytuly[$data->currentMenu['tekst']] : "";
$data->tplData["CMS_TEXT"] = isset($teksty[$data->currentMenu['tekst']]) ? $teksty[$data->currentMenu['tekst']] : "";
if (isset($inne[$data->currentMenu['tekst']]) && $inne[$data->currentMenu['tekst']]["aktywny"] == 1) {
    $data->tplData["CMS_IMAGE"] = isset($inne[$data->currentMenu['tekst']]["grafika"]) ? $inne[$data->currentMenu['tekst']]["grafika"] : "";
    $data->tplData["CMS_GALLERY"] = isset($inne[$data->currentMenu['tekst']]["galeria"]) ? $inne[$data->currentMenu['tekst']]["galeria"] : "";
    $data->tplData["CMS_GALLERY_DESCS"] = isset($inne[$data->currentMenu['tekst']]["galeria_opisy"]) ? $inne[$data->currentMenu['tekst']]["galeria_opisy"] : "";
}

// RENDERING DOCUMENT TO BUFFER

while (ob_get_level() > 0) ob_end_clean();
ob_start();

if (file_exists("templates/header.php")) include_once "templates/header.php"; else {
    http_response_code(404);
    exit();
}

if ((!isset($skipTop) || $skipTop !== true) && file_exists("templates/top.php")) include_once "templates/top.php"; 

if (!isset($data->currentMenu["typszablonu"]) || $data->currentMenu["typszablonu"] == "" || !file_exists("templates/{$data->currentMenu["typszablonu"]}")) $data->currentMenu["typszablonu"] = "page.php";

if (!file_exists("templates/{$data->currentMenu["typszablonu"]}")) $data->currentMenu["typszablonu"] = "home.php";

if (file_exists("templates/{$data->currentMenu["typszablonu"]}")) include_once "templates/{$data->currentMenu["typszablonu"]}";

if ((!isset($skipFooter) || $skipFooter !== true) && file_exists("templates/footer.php")) include_once "templates/footer.php";

if (DEFINED("LAZY_LOADING") && CONSTANT("LAZY_LOADING") === true) {
    $data->tplData["FOOTER_JS"] .= <<<JS
    <script type="text/javascript">
        $(document).ready(function() {
            $("img[data-src]").Lazy();
        });
    </script>
JS;
}

// PRESERVING DEPENDENCIES TAGS

if (!isset($data->tplData["HEADER_CSS"]) || strpos($data->tplData["HEADER_CSS"], "{#!HEADER_CSS!#}") === false) $data->tplData["HEADER_CSS"] = "{#!HEADER_CSS!#}" . $data->tplData["HEADER_CSS"];
if (!isset($data->tplData["HEADER_JS"]) || strpos($data->tplData["HEADER_JS"], "{#!HEADER_JS!#}") === false) $data->tplData["HEADER_JS"] = "{#!HEADER_JS!#}" . $data->tplData["HEADER_JS"];
if (!isset($data->tplData["FOOTER_CSS"]) || strpos($data->tplData["FOOTER_CSS"], "{#!FOOTER_CSS!#}") === false) $data->tplData["FOOTER_CSS"] = "{#!FOOTER_CSS!#}" . $data->tplData["FOOTER_CSS"];
if (!isset($data->tplData["FOOTER_JS"]) || strpos($data->tplData["FOOTER_JS"], "{#!FOOTER_JS!#}") === false) $data->tplData["FOOTER_JS"] = "{#!FOOTER_JS!#}" . $data->tplData["FOOTER_JS"];

// HERE YOU CAN ADD TEMPLATE VARIABLES TO SKIP AT FIRST PROCESSING
// IN CASE OF CHANGING THEM IN-PROCESS

if (isset($data->tplData["CUSTOM_HTML_CLASS"]) && $data->tplData["CUSTOM_HTML_CLASS"] != "") $data->tplData["CUSTOM_HTML_CLASS"] = " class=\"" . trim($data->tplData["CUSTOM_HTML_CLASS"], " ") . "\"";
if (isset($data->tplData["CUSTOM_BODY_CLASS"]) && $data->tplData["CUSTOM_BODY_CLASS"] != "") $data->tplData["CUSTOM_BODY_CLASS"] = " " . trim($data->tplData["CUSTOM_BODY_CLASS"], " ");

// RENDERING BUFFER TO BROWSER

if (DEFINED("ENV_TITLE")) $data->tplData["TITLE"] = ENV_TITLE . $data->tplData["TITLE"];
$data->buffer = ob_get_clean();
// Utils::processTemplate($data->buffer, $data->tplData, ["empty" => true, "save" => true, "noCalls" => true]);
// echo "<pre>";
// print_r(htmlentities($data->buffer));
// ob_start();
// print_r($data->tplData);
// echo htmlentities(ob_get_clean());
// echo "</pre>";

if (DEFINED("LAZY_LOADING") && CONSTANT("LAZY_LOADING") === true) {
    array_push($data->deps["header"]["js"][1], "js/jquery.lazy.min.js");
}

$allInOne = false;
if (DEFINED("ALL_IN_ONE") && CONSTANT("ALL_IN_ONE") === true) $allInOne = true;

ob_start();
if (DEFINED("ENV") && CONSTANT("ENV") != "prod") {
    header("Cache-Control: no-cache, no-store, must-revalidate");
    header("Pragma: no-cache");
    header("Expires: 0");
} else {
    $cacheDuration = 1 * 60 * 60 * 24; // one day in seconds;
    header("Cache-Control: max-age={$cacheDuration}");
}

echo Utils::processTemplate($data->buffer, $data->tplData, ["empty" => false]);
$data->buffer = ob_get_clean();

$data->buffer = str_replace("{#!HEADER_CSS!#}", Utils::includeDependencies($data->deps["header"]["css"], "", ["rel" => "stylesheet", "type" => "text/css"], "href", "link", false, $allInOne), $data->buffer);
$data->buffer = str_replace("{#!HEADER_JS!#}", Utils::includeDependencies($data->deps["header"]["js"], "", ["type" => "text/javascript"], "src", "script", true, $allInOne), $data->buffer);
$data->buffer = str_replace("{#!FOOTER_CSS!#}", Utils::includeDependencies($data->deps["footer"]["css"], "", ["rel" => "stylesheet", "type" => "text/css"], "href", "link", false, $allInOne), $data->buffer);
$data->buffer = str_replace("{#!FOOTER_JS!#}", Utils::includeDependencies($data->deps["footer"]["js"], "", ["type" => "text/javascript"], "src", "script", true, $allInOne), $data->buffer);

echo $data->buffer;

if (DEFINED("LAZY_LOADING") && CONSTANT("LAZY_LOADING") === true) {
    $data->buffer = ob_get_clean();
    $data->buffer = preg_replace_callback("/<img\s.*(src)=[^\s]+[\s>]/ui", function($f) {
        return str_replace($f[1], "data-src", $f[0]);
    }, $data->buffer);
    ob_start();
    echo $data->buffer;
}

@flush();
@ob_end_flush();

http_response_code(200);
exit();
