    {%SEARCH_IMAGE%}
    <section class="search__header--wrapper">
        <header class="container container--search search__header">
            <h1 class="search__header--title">{%MENU_NAME%}</h1>
            <div class="search__header--content">{%CMS_TEXT%}
                <p>{%SEARCH_RESULTS_FOR_PHRASES%} {%SEARCH_PHRASES%}</p>
                <p>{%SEARCH_RESULTS_COUNTS%}</p>
            </div>
        </header>
    </section>
    <section class="container container--search search__content">
        {%SEARCH_RESULTS%}
    </section>

<?php
if (isset($menu[9]["flink"]) && $menu[9]["flink"] != "" && isset($_GET[$menu[9]["flink"]])) {
    $_GET[$menu[9]["flink"]] = str_replace(["\r\n", "\n"], ["/", "/"], $_GET[$menu[9]["flink"]]);
    header("Location: {$data->tplData["STATIC_ROOT"]}{$menu[9]['flink']}/" . $_GET[$menu[9]["flink"]]);
    exit();
}
$data->tplData["CUSTOM_BODY_CLASS"] = "search";
if (isset($data->currentMenu["grafika"]) && $data->currentMenu["grafika"] != "") $data->tplData["SEARCH_IMAGE"] = "<img class=\"search__image\" src=\"{$data->currentMenu['grafika']}\" title=\"{$data->currentMenu['title']}\">";

$data->tplData["SEARCH_RESULTS_COUNTS"] = [];

// NORMALIZE QUERY
if (count($routes) > 0) {
    foreach ($routes as &$route) $route = trim(preg_replace("/\s+/is", " ", preg_replace("/[^ąćęłńóśźża-z0-9 ]/uis", " ", rawurldecode($route))));

    $data->tplData["SEARCH_PHRASES"] = implode(", ", array_map(function($item) {
        return "'{$item}'";
    }, $routes));

    // SEARCH ARTICLES
    $query = "SELECT %s FROM `%s{$lang}` WHERE `aktywny` = 1 AND ";
    $conds = [
        "aktualnosci" => ["*", "tytul", "tekst_krotki", "tekst_dlugi", "data"],
        "kategorie" => ["*", "nazwa", "opis"],
        "produkty" => ["*", "nazwa", "opis"],
        "teksty" => ["id", "tresc"]
    ];
    $queries = [];
    foreach ($conds as $table => $cond) {
        $select = array_shift($cond);
        $tmp = [];
        for ($i = 0; $i < count($routes); $i++) {
            $tmp2 = [];
            foreach ($cond as &$item) {
                array_push($tmp2, "`{$item}` LIKE \"%" . $routes[$i] . "%\"");
            }
            array_push($tmp, "(" . implode(" OR ", $tmp2). ")");
        }
        $queries[$table] = sprintf($query, $select, $table) . "(" . implode(" OR ", $tmp). ")";
    }

    // QUERYING
    ob_start();
    $data->tplData["SEARCH_RESULTS_TABS"] = "<div class=\"search__tabs\">";

    // PRODUCTS
    $searchedProducts = $data->db->query($queries["produkty"] . " ORDER BY `kol` ASC");
    if (!isset($data->products)) $data->products = [];
    $searchedProductsIDs = [];
    foreach ($searchedProducts as $item) {
        $data->products[$item["id"]] = $item;
        array_push($searchedProductsIDs, $item["id"]);
    }

    if (count($searchedProducts) > 0) {
        $data->tplData["SEARCH_RESULTS_TABS"] .= "<label for=\"search__radio--products\">{$data->tplData['PRODUCTS']}: " . count($searchedProducts) . "</label>";
        echo "<input type=\"radio\" id=\"search__radio--products\" class=\"search__radio\" name=\"search__radio\">";
        echo $data->tplData["CATEGORY_PRODUCTS_GRID_CUSTOM"]($data->tplData["PRODUCTS"] . ": " . count($searchedProducts), 1, $searchedProductsIDs);
        $data->tplData["SEARCH_RESULTS_COUNTS"][] = $data->tplData["PRODUCTS"] . ": " . count($searchedProducts);
    }

    // NEWS
    $searchedNews = $data->db->query($queries["aktualnosci"] . " ORDER BY `data` DESC, `id` DESC");
    if (!isset($data->news)) $data->news = [];
    $searchedNewsIDs = [];
    foreach ($searchedNews as $item) {
        $data->news[$item["id"]] = $item;
        array_push($searchedNewsIDs, $item["id"]);
    }

    if (count($searchedNews) > 0) {
        $data->tplData["SEARCH_RESULTS_TABS"] .= "<label for=\"search__radio--news\">{$data->tplData['NEWS']}: " . count($searchedNews) . "</label>";
        echo "<input type=\"radio\" id=\"search__radio--news\" class=\"search__radio\" name=\"search__radio\">";
        echo "<div class=\"search__news\">";
        echo $data->tplData["ARTICLES_LIST"]($searchedNewsIDs);
        echo "</div>";
        $data->tplData["SEARCH_RESULTS_COUNTS"][] = $data->tplData["NEWS"] . ": " . count($searchedNews);
    }

    // CATEGORIES
    $searchedCategories = $data->db->query($queries["kategorie"] . " ORDER BY `kol` ASC, `id` ASC");
    if (!isset($data->categories)) $data->categories = [];
    $searchedCategoriesIDs = [];
    foreach ($searchedCategories as $item) {
        $data->nategories[$item["id"]] = $item;
        array_push($searchedCategoriesIDs, $item["id"]);
    }

    if (count($searchedCategories) > 0) {
        $data->tplData["SEARCH_RESULTS_TABS"] .= "<label for=\"search__radio--categories\">{$data->tplData['CATEGORIES']}: " . count($searchedCategories) . "</label>";
        echo "<input type=\"radio\" id=\"search__radio--categories\" class=\"search__radio\" name=\"search__radio\">";
        echo $data->tplData["CATEGORIES_LIST_COLUMN"]($searchedCategoriesIDs);
        $data->tplData["SEARCH_RESULTS_COUNTS"][] = $data->tplData["CATEGORIES"] . ": " . count($searchedCategories);
    }

    // PAGES
    $searchedPages = $data->db->query($queries["teksty"]);
    $tmp = [];
    foreach ($searchedPages as $page) array_push($tmp, $page["id"]);
    $searchedMenus = [];
    foreach ($menu as $item) {
        if (array_search($item["tekst"], $tmp) !== false) array_push($searchedMenus, $item);
    }
    if (count($searchedMenus) > 0) {
        echo "<input type=\"radio\" id=\"search__radio--pages\" class=\"search__radio\" name=\"search__radio\">";
        echo "<div class=\"search__pages\">";
        foreach ($searchedMenus as $key => $item) {
            if ($item["link"] == "#" || $item["pokaz"] != 1) {
                unset($searchedMenus[$key]);
                continue;
            }
            echo "<a href=\"{$item['link']}\" title=\"{$item['nazwa']}\">{$item['nazwa']}</a><br>";
        }
        echo "</div>";
        $data->tplData["SEARCH_RESULTS_TABS"] .= "<label for=\"search__radio--pages\">{$data->tplData['PAGES']}: " . count($searchedMenus) . "</label>";
        $data->tplData["SEARCH_RESULTS_COUNTS"][] = $data->tplData["PAGES"] . ": " . count($searchedMenus);
    }

    $data->tplData["SEARCH_RESULTS_COUNTS"] = implode(", ", $data->tplData["SEARCH_RESULTS_COUNTS"]);

    $data->tplData["SEARCH_RESULTS_TABS"] .= "</div>";

    $data->tplData["SEARCH_RESULTS"] = $data->tplData["SEARCH_RESULTS_TABS"] . ob_get_clean();
    $totalResultsCount = count($searchedProducts) + count($searchedNews) + count($searchedCategories) + count($searchedMenus);
}

if (count($routes) == 0 || $totalResultsCount == 0) {
    $data->tplData["SEARCH_RESULTS_COUNTS"] = trim($data->tplData["NO_RESULTS"], " .");
    $data->tplData["SEARCH_RESULTS"] = $data->tplData["NO_RESULTS"];
}
